#ifndef _BoardP_h
#define _BoardP_h

#include "Board.h"
/* include superclass private header file */
#include <X11/CoreP.h>

/* define unique representation types not found in <X11/StringDefs.h> */

/*#define XtRBlackForeground "BlackForeground"
#define XtRBlackBackground "BlackBackground"
#define XtRRedForeground "RedForeground"
#define XtRRedBackground "RedBackground"*/

typedef struct {
    int empty;
} BoardClassPart;

typedef struct _BoardClassRec {
    CoreClassPart	core_class;
    BoardClassPart	board_class;
} BoardClassRec;

extern BoardClassRec boardClassRec;

typedef struct {
    /* resources */
    Dimension	line_width;
    Dimension	border_width;
    Pixel	foreground;
    Pixel	black_fg, red_fg;
    Pixel	black_bg, red_bg;
    Pixel	black_bd, red_bd;
    XFontStruct	*font;
    Side	side, turn;
    XtCallbackList moved_callbacks;
    int		blink_interval;

    /* private state */
    Position	origin_x, origin_y;
    Dimension	spacing, radius;

    Pixmap	pieces_pixmap[14];
    Pixmap	mask_pixmap;

    Piece	pieces[COLS][ROWS];
    Pixmap	board_pixmap, grid_pixmap, temp_pixmap;
    GC		fg_gc, bg_gc, copy_gc, black_gc, red_gc;

    Cursor	move_cursor;

    Boolean	check;

    int		blink_i, blink_j;
    Piece	blink_pc;
    Boolean	blink_on, blink_show;
    XtIntervalId blink_id;

} BoardPart;

typedef struct _BoardRec {
    CorePart	core;
    BoardPart	board;
} BoardRec;

#endif /* _BoardP_h */
