#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>

#include <netinet/in.h>

#include <stdio.h>
#include <netdb.h>

extern void DataIn(), DataOut();

#define	IPPORT_CCHESS	6606

int server = 0;

struct data {
	int i, j, ni, nj;
};

netopen(host)
	char *host;
{
	int s;
	struct sockaddr_in sin;
	struct hostent *hp;
	int one = 1;

	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s < 0) {
		perror("socket");
		exit (-1);
	}

	if (host == NULL) {
		sin.sin_family = AF_INET;
		sin.sin_addr.s_addr = INADDR_ANY;
		sin.sin_port = htons(IPPORT_CCHESS);
		if (bind(s, &sin, sizeof(sin)) < 0) {
			perror("bind");
			exit(-1);
		}
		listen(s, 5);
		server = 1;
		ioctl(s, FIONBIO, &one);
		return s;
	}

	hp = gethostbyname(host);
	if (hp == NULL) {
		if ((sin.sin_addr.s_addr = inet_addr(host)) == -1) {
			fprintf(stderr, "%s: unknown host\n", host);
			exit(1);
		}
		sin.sin_family = INADDR_ANY;
	} else {
		sin.sin_family = hp->h_addrtype;
		bcopy(hp->h_addr, &sin.sin_addr, hp->h_length);
	}
	sin.sin_port = htons(IPPORT_CCHESS);

	if (connect(s, &sin, sizeof(sin)) < 0) {
		perror("connect");
		exit(-1);
	}

	ioctl(s, FIONBIO, &one);
	return s;
}

void
netread(p, sp, id)
	struct data *p;
	int *sp;
	int *id;
{
	int s;
	struct sockaddr_in sin;
	int len = sizeof(sin);
	int cc;

	if (server == 1) {
		s = accept(*sp, &sin, &len);
		if (s < 0)
			return;
		dup2(s, *sp);
		server = 0;
		return;
	}

	s = *sp;
	cc = read(s, p, sizeof(struct data));
	if (cc <= 0) {
		if (cc < 0) {
			perror("read");
			exit(-1);
		}
		exit(0);
	}
	/*fprintf(stderr, "r: (%d,%d)->(%d,%d)\n", p->i, p->j, p->ni, p->nj);*/

	DataIn(p, *id);
}

netwrite(p, sp, id)
	struct data *p;
	int *sp;
	int *id;
{
	int s = *sp;
	int cc;

	cc = write(s, p, sizeof(struct data));
	if (cc <= 0) {
		if (cc < 0) {
			perror("write");
			exit(-1);
		}
		exit(0);
	}
	/*fprintf(stderr, "w: (%d,%d)->(%d,%d)\n", p->i, p->j, p->ni, p->nj);*/

	DataOut(p, *id);
}
